require 'modshogun'

f_feats_train = modshogun.CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = modshogun.CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = modshogun.CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")
f_labels_test = modshogun.CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat")

--![create_features]
features_train = modshogun.RealFeatures(f_feats_train)
features_test = modshogun.RealFeatures(f_feats_test)
labels_train = modshogun.MulticlassLabels(f_labels_train)
labels_test = modshogun.MulticlassLabels(f_labels_test)
--![create_features]

--![choose_distance]
distance = modshogun.EuclideanDistance(features_train, features_train)
--![choose_distance]

--![create_instance]
k = 3
knn = modshogun.KNN(k, distance, labels_train)
--![create_instance]

--![train_and_apply]
knn:train()
labels_predict = knn:apply_multiclass(features_test)
--![train_and_apply]

--![evaluate_accuracy]
eval = modshogun.MulticlassAccuracy()
accuracy = eval:evaluate(labels_predict, labels_test)
--![evaluate_accuracy]

-- additional integration testing variables
output = labels_predict:get_labels()

-- Serialize output for integration testing (automatically generated)
__sg_storage = modshogun.WrappedObjectArray()
__sg_storage_file = modshogun.SerializableAsciiFile("knn.dat", 'w')
__sg_storage:append_wrapped_int(k, "k")
__sg_storage:append_wrapped_real(accuracy, "accuracy")
__sg_storage:append_wrapped_real_vector(output, "output")
__sg_storage:save_serializable(__sg_storage_file)
