library(shogun)

f_feats_train <- CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")

Math$init_random(1)

#![create_features]
features_train <- RealFeatures(f_feats_train)
#![create_features]

#![create_gmm_instance]
num_components <- 3
gmm <- GMM(num_components)
#![create_gmm_instance]

#![train_sample]
gmm$set_features(features_train)
gmm$train_em()
output <- gmm$sample()
#![train_sample]

#![training_smem]
gmm$train_smem()
#![training_smem]

#![extract_params]
component_num <- 1
nth_mean <- gmm$get_nth_mean(component_num)
nth_cov <- gmm$get_nth_cov(component_num)
coef <- gmm$get_coef()
#![extract_params]

#![cluster_output]
log_likelihoods <- gmm$cluster(nth_mean)
#![cluster_output]

# Serialize output for integration testing (automatically generated)
__sg_storage <- WrappedObjectArray()
__sg_storage_file <- SerializableAsciiFile("gmm.dat", 'w')
__sg_storage$append_wrapped_int(num_components, "num_components")
__sg_storage$append_wrapped_real_vector(output, "output")
__sg_storage$append_wrapped_int(component_num, "component_num")
__sg_storage$append_wrapped_real_vector(nth_mean, "nth_mean")
__sg_storage$append_wrapped_real_matrix(nth_cov, "nth_cov")
__sg_storage$append_wrapped_real_vector(coef, "coef")
__sg_storage$append_wrapped_real_vector(log_likelihoods, "log_likelihoods")
__sg_storage$save_serializable(__sg_storage_file)
