require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_labels_test.dat"

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::BinaryLabels.new f_labels_train
labels_test = Modshogun::BinaryLabels.new f_labels_test
#![create_features]

#![create_instance]
lda = Modshogun::LDA.new 
lda.set_features features_train
lda.set_labels labels_train
#![create_instance]

#![train_and_apply]
lda.train 
labels_predict = lda.apply_binary features_test
#![train_and_apply]

#![extract_weights]
w = lda.get_w 
#![extract_weights]

#![evaluate_accuracy]
eval = Modshogun::AccuracyMeasure.new 
accuracy = eval.evaluate labels_predict, labels_test
#![evaluate_accuracy]

#additional integration testing variables
output = labels_predict.get_labels 

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "lda.dat", 'w'
__sg_storage.append_wrapped_real_vector w, "w"
__sg_storage.append_wrapped_real accuracy, "accuracy"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
