require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_test.dat"
Modshogun::Math.init_random 1

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::MulticlassLabels.new f_labels_train
labels_test = Modshogun::MulticlassLabels.new f_labels_test
#![create_features]

#![set_attribute_types]
ft = Modshogun::BoolVector.new 2
ft.set_element false, 0
ft.set_element false, 1
#![set_attribute_types]

#![create_instance]
classifier = Modshogun::CARTree.new ft, Modshogun::PT_MULTICLASS, 5, true
classifier.set_labels labels_train
#![create_instance]

#![train_and_apply]
classifier.train features_train
labels_predict = classifier.apply_multiclass features_test
#![train_and_apply]

#![evaluate_accuracy]
eval = Modshogun::MulticlassAccuracy.new 
accuracy = eval.evaluate labels_predict, labels_test
#![evaluate_accuracy]

# integration testing variables
output = labels_predict.get_labels 

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "cartree.dat", 'w'
__sg_storage.append_wrapped_real accuracy, "accuracy"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
